<?php 
require_once("icwfData.inc.php");

class KDbLog implements icwfData {
  private static $noExport = array();
  private static $notInArray = array();
  
  private $log_id;
  private $timestamp;
  private $db_admin_id;
  private $log_entry;
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // initialize
  private function initialize() {
    foreach ($this as $key => $value)
      $this->$key = null;
  }
  
  public function __construct(FormValidation $validation) {
    $this->initialize();
    $this->validation = $validation;
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////
  // get values
  public function __get($name) {
    if($name == "id") $name = "log_id";
    if (array_key_exists($name, get_class_vars(get_class())) && !in_array($name, self::$noExport))
      return $this->$name;
      
    return null;
  }

  public function getIDName() {
    return "log_id";
  }
  
  public function toArray() {
    $array = array();
    foreach ($this as $key => $value)
      if(!in_array($key, self::$notInArray))
        $array[$key] = $value; 
    return $array;
  }
  
  public function getPostBackData() {
    return array($this->getIDName()=>$this->id);
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // set values
  public function setValidation(FormValidation $validation) {

  }
  
  public function fromArray($array) {
    foreach ($this as $key => $value) {
      switch ($key) {
        case "log_id":
        case "db_admin_id":
          if(isset($array[$key]) && preg_match('~^[0-9]+$~', $array[$key]))
            $this->$key = $array[$key];
          else
            $this->$key = null;
          break;
        case "log_entry":
        default:
          if(isset($array[$key]))
            $this->$key = $array[$key];
          else
            $this->$key = null;
          break;
      }
    }
    return true;
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - read
  public function readData(DbConnection $DB, $conditions) {
    if(is_array($conditions)) {
      $whereConditions = array();
      foreach ($conditions as $key => $value)
        if(array_key_exists($key, get_class_vars(get_class())))
          $whereConditions[] = "$key=$value";
      $conditions =  implode(" AND ", $whereConditions);
    }
    $result = $DB->query("SELECT * FROM kdb_log WHERE {$conditions};");
    
    if(!$DB->errno() && $DB->num_rows($result)>0) {
      $group = $DB->fetch_array($result);
      foreach ($group as $property => $value)
        if(property_exists($this, $property))
          $this->$property = $value;
      
      return array(0, "");
    }
    else
      return array($DB->errno(), $DB->error());
  }
  
  static public function readList(DbConnection $DB) {
    $list = array();
    return $list;
  }
  
  static public function printLogTable(DbConnection $DB) {
    $result = $DB->query("SELECT timestamp, login admin, log_entry FROM kdb_log kl LEFT JOIN db_admins da ON da.db_admin_id=kl.db_admin_id ORDER BY timestamp DESC LIMIT 250;");
    echo $DB->error();
    while ($logEntry = $DB->fetch_array($result)) {
      echo "<tr>\n";
      echo "  <td style=\"white-space:nowrap;\">{$logEntry['timestamp']}</td>\n";
      echo "  <td style=\"white-space:nowrap;\">{$logEntry['admin']}</td>\n";
      echo "  <td>{$logEntry['log_entry']}</td>\n";
      echo "</tr>\n";
    }
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - write
  public function writeData(DbConnection $DB) {
    return array(0, "");
  }

  static public function writeLog(DbConnection $DB, $logEntry) {
    $logEntry = str_replace("'", '"', $logEntry);
    $result = $DB->query("INSERT INTO kdb_log(
        timestamp,
        db_admin_id,
        log_entry
      ) VALUES(
        NOW(),
        '{$_SESSION['admin']['db_admin_id']}',
        '{$logEntry}'
        );");
    
    return array($DB->errno(), $DB->error());
  }

  static public function deleteData(DbConnection $DB, $id) {
    return array(0, "");
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - misc
  static public function createTable(DbConnection $DB) {
    $result = $DB->query("
      CREATE TABLE kdb_log (
        log_id int unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY,
        timestamp datetime,
        db_admin_id int unsigned NOT NULL,
        log_entry text,
        INDEX db_admin_id (db_admin_id)
      );");
    if ($result) { echo _("&nbsp;&nbsp;- creating table").": 'kdb_log'.<br>\n"; }
    else { echo _("&nbsp;&nbsp;<b>- Error when creating table</b>")." 'kdb_log'<br>\n"; $error = 1; }
  }
}
?>