<?php
require_once("CWFMainUI.inc.php");

class MainAdminUI extends CWFMainUI {
  /* ****************************************************************************************
   * Constructor
   */
  final public function __construct(DbConnection $DB, $displayMenu=true) {
    parent::__construct(false);
    $this->displayMenu = $displayMenu;
    $_SESSION['lang'] = $this->getLanguage();
    $this->absolutePath = CWF_HTTP_PATH."admin/";
    
    switch (ADMIN_LOGIN_MODE) {
      case LOGIN_MODE_IP_OR_PW:
      case LOGIN_MODE_IP:
        $login = new DbAdmin();
        list($errno, $error) = $login->readData($DB, "(ip_addresses LIKE '%{$_SERVER['REMOTE_ADDR']}%')
          OR (ip_addresses LIKE CONCAT('%', SUBSTRING_INDEX('{$_SERVER['REMOTE_ADDR']}', '.', 3), '.0/24%'))
          OR (ip_addresses LIKE CONCAT('%', SUBSTRING_INDEX('{$_SERVER['REMOTE_ADDR']}', '.', 2), '.0.0/16%'))
          OR (ip_addresses LIKE CONCAT('%', SUBSTRING_INDEX('{$_SERVER['REMOTE_ADDR']}', '.', 1), '.0.0.0/8%'))");
        if(!$errno)
          $_SESSION['admin'] = $login->toArray();
        else if(ADMIN_LOGIN_MODE==LOGIN_MODE_IP) {
          $this->errorMsg = "<p>"._("Login failed").($errno ? " ({$error})" : "").".</p>\n";
          break;
        }
        
      case LOGIN_MODE_PASSWD:
        if(isset($_POST['kdb_submit_login']) && $_POST['kdb_submit_login']) {
          $login = new DbAdmin();
          list($errno, $error) = $login->readData($DB, array("login"=>"'{$_POST['admin_login']}'"));
          if(!$errno && $login->checkPW($_POST['admin_passwd']))
            $_SESSION['admin'] = $login->toArray();
          else
            $this->errorMsg = "<p>"._("Login failed").($errno ? " ({$error})" : "").".</p>\n";
        }
        break;
        
      case LOGIN_MODE_IP_AND_PW:
        if(isset($_POST['kdb_submit_login']) && $_POST['kdb_submit_login']) {
          $login = new DbAdmin();
          list($errno, $error) = $login->readData($DB, "login='{$_POST['admin_login']}'
            AND ((ip_addresses LIKE '%{$_SERVER['REMOTE_ADDR']}%')
              OR (ip_addresses LIKE CONCAT('%', SUBSTRING_INDEX('{$_SERVER['REMOTE_ADDR']}', '.', 3), '.0/24%'))
              OR (ip_addresses LIKE CONCAT('%', SUBSTRING_INDEX('{$_SERVER['REMOTE_ADDR']}', '.', 2), '.0.0/16%'))
              OR (ip_addresses LIKE CONCAT('%', SUBSTRING_INDEX('{$_SERVER['REMOTE_ADDR']}', '.', 1), '.0.0.0/8%')))");
          
          $login->readData($DB, array("login"=>"'{$_POST['admin_login']}'"));
          if(!$errno && $login->checkPW($_POST['admin_passwd']))
            $_SESSION['admin'] = $login->toArray();
          else
            $this->errorMsg = "<p>"._("Login failed").($errno ? " ({$error})" : "").".</p>\n";
        }
        break;
    }
    
    if($this->displayMenu)
      $this->MENU = $this->createMenu();
    
    Plugins::addMenuItems($this);
  }

  /* ****************************************************************************************
   * Print page header
   */
  final public function writeHeader($currentMenu, $title, $addHeader) {
    global $DB;
?>
<!doctype html>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel="stylesheet" href="<?php echo CWF_HTTP_PATH; ?>k_db/css/main.css" type="text/css">
  <link rel="stylesheet" href="<?php echo CWF_HTTP_PATH; ?>k_db/css/admin.css" type="text/css">
  <script type="text/javascript">var CWF_HTTP_Path="<?php echo CWF_HTTP_PATH; ?>"</script>
  <script src="<?php echo CWF_HTTP_PATH; ?>cwf/js/jquery-1.10.2.min.js" type="text/javascript"></script>
  <script src="<?php echo CWF_HTTP_PATH; ?>cwf/js/jquery.hoverIntent.js" type="text/javascript"></script>
  <script src="<?php echo CWF_HTTP_PATH; ?>cwf/js/jquery.validate.min.js"	type="text/javascript"></script>
  <script src="<?php echo CWF_HTTP_PATH; ?>cwf/js/jquery.form.js"	type="text/javascript"></script>
  <script src="<?php echo CWF_HTTP_PATH; ?>k_db/js/ajaxTextAdmin.js.php" type="text/javascript"></script>
  <script src="<?php echo CWF_HTTP_PATH; ?>cwf/js/cwfCommon.js" type="text/javascript"></script>
  <script src="<?php echo CWF_HTTP_PATH; ?>k_db/js/kdb_admin_main.js" type="text/javascript"></script>
  <script src="<?php echo CWF_HTTP_PATH; ?>cwf/js/validation_rules.js" type="text/javascript"></script>
<?php
    echo $addHeader;
    if(defined("CSS_SKIN") && CSS_SKIN!="") echo "  <link rel=\"stylesheet\" href=\"".CWF_HTTP_PATH."k_db/css/skins/".CSS_SKIN."_admin.css\" type=\"text/css\">\n";
    echo "  <title>KDb Adminstration".(($title) ? " - $title" : "")."</title>\n";
?>
</head>
<body>

<div id="logo"></div>

<div id="ajax_message">
  <div id="ajax_message_bg"></div>
  <div id="ajax_message_container"></div>
</div>

<div id="menu">
<?php
  if ($this->displayMenu)
    echo $this->getMenuHTML($DB, $currentMenu);
?>
</div>
<div id="content">

<?php
    if($this->fatalError)
      $this->displayPage = false;
    
    if(!isset($_SESSION['admin']) && !$this->fatalError && $this->displayMenu) {
      $this->displayPage = false;
      echo "<form id=\"kdb_form\" action=\"\" method=\"post\" enctype=\"multipart/form-data\">\n";
      echo "<div id=\"center\" class=\"login_form\">\n";
      if ($this->errorMsg == "")
        echo "<div id=\"error_message\"></div>\n";
      else
        echo "<div id=\"error_message\" style=\"display:block;\">{$this->errorMsg}</div>\n";
    
      echo "<p><label for=\"current_ip\">("._("Login from").":</label>\n";
      echo "  <span id=\"current_ip\" class=\"form_element\">{$_SERVER['REMOTE_ADDR']})</span></p>\n";
      echo "<p><label for=\"admin_login\">"._("Username").":</label>\n";
      echo "  <input type=\"text\" id=\"admin_login\" name=\"admin_login\" value=\"\"></p>\n";
      echo "<p><label for=\"admin_passwd\">"._("Password").":</label>\n";
      echo "  <input type=\"password\" id=\"admin_passwd\" name=\"admin_passwd\" value=\"\"></p>\n";
      echo "<p><label for=\"kdb_submit_login\"></label>\n";
      echo "  <input type=\"submit\" id=\"kdb_submit_login\" name=\"kdb_submit_login\" value=\""._("Login")."\"></p>\n";
      echo "</div>\n";
      echo "</form>\n";
    }
    else {
      if ($this->errorMsg == "")
        echo "<div id=\"error_message\"></div>\n";
      else
        echo "<div id=\"error_message\" style=\"display:block;\">\n{$this->errorMsg}</div>\n";
    }
    
    return $this->displayPage;
  }

  /* ****************************************************************************************
   * Print page footer
   */
  final public function writeFooter() {
?>
</div>
</body>
</html>
<?php
  }
  
  /* ****************************************************************************************
   * Create menu array
   */
  protected function createMenu() {
    /*
     * title:      String
     * url:        String (starting with "!": link is disabled, use rest of url as title attribute text
     * permission: array('type'=>(user|perm), 'rule'=>String
     * submenu:    array of menupoints
     */
    return array(
      'Configuration'=>array('title'=>_('Configuration'), 'url'=>'', 'permission'=>'', 'submenu'=>array(
        'Events'=>array('title'=>_('Events'), 'url'=>'', 'permission'=>'', 'submenu'=>array(
          'Event'=>array('title'=>_('Event'),               'url'=>'index.php/event',         'permission'=>array("type"=>"perm", "rule"=>"edit_event"), 'submenu'=>''),
          'Forms'=>array('title'=>_('Forms'),               'url'=>'index.php/event_forms',   'permission'=>array(array("type"=>"perm", "rule"=>"edit_fees"), array("type"=>"isset", "rule"=>'$_SESSION["event"]', "message"=>_("No event selected."))),  'submenu'=>''),
          //'Topics'=>array('title'=>_('Topics'),             'url'=>'!index.php/topics',       'permission'=>'', 'submenu'=>'')
        )),
        'hr1'=>array('title'=>'',                               'url'=>'',                           'permission'=>'', 'submenu'=>''),
        //'Payment_Options'=>array('title'=>_('Payment Options'), 'url'=>'!index.php/payment_options', 'permission'=>'', 'submenu'=>''),
        'Saluations'=>array('title'=>_('Salutations'),          'url'=>'index.php/salutations',      'permission'=>array("type"=>"perm", "rule"=>"edit_salutations"), 'submenu'=>''),
        'Countries'=>array('title'=>_('Countries'),             'url'=>'index.php/countries',        'permission'=>array("type"=>"user", "rule"=>"root"),             'submenu'=>''),
        'Disclaimers'=>array('title'=>_('Disclaimers'),         'url'=>'index.php/disclaimers',      'permission'=>array("type"=>"perm", "rule"=>"edit_disclaimers"), 'submenu'=>''),
        'DisclaimersView'=>array('title'=>_('Disclaimers'),     'url'=>'index.php/disclaimers_view', 'permission'=>array("type"=>"perm", "rule"=>"edit_disclaimers", "not"=>1), 'submenu'=>''),
        'hr2'=>array('title'=>'',                               'url'=>'',                           'permission'=>'', 'submenu'=>''),
        'K_Db_Options'=>array('title'=>_('K_Db Options'),       'url'=>'index.php/kdb_options',      'permission'=>array("type"=>"perm", "rule"=>"kdb_options"), 'submenu'=>''),
        //'Update_K_Db'=>array('title'=>_('Update K_Db'),         'url'=>'!index.php/update_kdb',      'permission'=>'', 'submenu'=>''),
        'Display_Log'=>array('title'=>_('Display Log'),         'url'=>'index.php/log',              'permission'=>array("type"=>"user", "rule"=>"root"), 'submenu'=>'')
      )),
      'View_Data'=>array('title'=>_('View Data'), 'url'=>'', 'permission'=>'', 'submenu'=>array(
        'Statistics'=>array('title'=>_('Statistics'),               'url'=>'index.php',                 'permission'=>'', 'submenu'=>''),
        'Create_edit_Views'=>array('title'=>_('Create/edit Views'), 'url'=>'index.php/edit_views',      'permission'=>array("type"=>"perm", "rule"=>"edit_views"), 'submenu'=>''),
        'hr1'=>array('title'=>'',                                   'url'=>'',                          'permission'=>'', 'submenu'=>''),
        'Views'=>array('title'=>_('Views'),                         'url'=>'',                          'permission'=>'', 'submenu'=>View::getMenuArray()),
        'hr2'=>array('title'=>'',                                   'url'=>'',                          'permission'=>'', 'submenu'=>''),
        'Add_Registration'=>array('title'=>_('Add registrations'),   'url'=>'index.php/add_reg',         'permission'=>array(array("type"=>"perm", "rule"=>"add_registrations"), array("type"=>"isset", "rule"=>'$_SESSION["event"]', "message"=>_("No event selected."))), 'submenu'=>''),
        'Deleted_entries'=>array('title'=>_('Deleted records'),     'url'=>'index.php/deleted_records', 'permission'=>array("type"=>"user", "rule"=>"root"), 'submenu'=>'')
      )),
      'User'=>array('title'=>_('User'), 'url'=>'', 'permission'=>'', 'submenu'=>array(
        'Profile'=>array('title'=>_('Profile'),         'url'=>'index.php/profile',     'permission'=>'', 'submenu'=>''),
        'Edit_Users'=>array('title'=>_('Edit Admins'),  'url'=>'index.php/edit_admins', 'permission'=>array("type"=>"perm", "rule"=>"edit_admins"),      'submenu'=>''),
        'Edit_Groups'=>array('title'=>_('Edit Groups'), 'url'=>'index.php/edit_groups', 'permission'=>array("type"=>"perm", "rule"=>"edit_admingroups"), 'submenu'=>''),
        'Send_Email'=>array('title'=>_('Send Email'),   'url'=>'index.php/send_email',  'permission'=>array("type"=>"user", "rule"=>"root"),             'submenu'=>''),
        'Log_out'=>array('title'=>_('Log out'),         'url'=>'logout.php',            'permission'=>'', 'submenu'=>'')
      ))
    );
  }

  /* ****************************************************************************************
   * Create menu array
   */
  public function getEventSelectList(DbConnection $DB, $padding="") {
    $str = $padding."<select id=\"eventList\" name=\"eventList\" onChange=\"kdbChooseEvent(this);\">\n";
    $str .= $padding."  <option value=\"-1\">"._("Choose event")."</option>\n";
    $events = Event::readList($DB);
    $activeLast = -1;
    foreach ($events as $event) {
      if ($activeLast <> $event['active']) {
        if($activeLast>=0) $str .= $padding."  </optgroup>\n";
        if ($event['active']==1)
          $str .= $padding."  <optgroup label=\""._("Active events")."\">\n";
        else
          $str .= $padding."  <optgroup label=\""._("Old events")."\">\n";
        $activeLast = $event['active'];
      }
      
      $addOptions = "";

      if(isset($_SESSION['event']) && $_SESSION['event']->event_id==$event['id'])
        $addOptions = " selected";
      if($_SESSION['admin']['login']!= "root" && $event['db_admin_group_id'] && 
         !in_array($event['db_admin_group_id'], $_SESSION['admin']['db_admin_group_ids']))
        $addOptions = " disabled";

      $str .= $padding."    <option value=\"{$event['id']}\"{$addOptions}>{$event['name']}</option>\n";
    }
    $str .= $padding."</select>\n";
    return $str;
  }
  
  public function getMenuHTML(DbConnection $DB, $currentMenu) {
    $str = "";
    if(isset($_SESSION['admin']) && !$_SESSION['admin']['first_login'] && !$this->fatalError) {
      $str .= "  <ul id=\"dropdownmenu\">\n";
      $str .= $this->getMenu($currentMenu, $this->MENU);
    
      $str .= "    <li id=\"menu_event_list\" class=\"menutitem\">\n";
      $str .= $this->getEventSelectList($DB, "      ");
      $str .= "    </li>\n";
      $str .= "  </ul>\n";
    }
    
    return $str;
  }
}
?>
