<?php
require_once("cwfUI.inc.php");

class SalutationUI extends cwfUI {
  protected static $accessRight = "edit_salutations";
  protected static $dataClass = "Salutation";
  
  public function __construct() {
    parent::__construct();
    $this->initialize();
  }
  
  protected function initialize() {
    parent::initialize();
    $this->title = _("Salutations");
  }
    
  static public function getValidationRules() {
    $rules = array(
        "salutation"=>array("required"=>true)
      );
    $messages = array(
        "salutation"=>_("Please enter a salutation.")
      );
    
    $validationRules = new FormValidation($rules, $messages);
    return $validationRules;
  }
  
  public function getHTML(DbConnection $DB) {
?>
<form id="kdb_form" action="" method="post" enctype="multipart/form-data">
<p>
  <label for="salutation_list"><?= _("Salutations") ?>:</label>
  <select id="salutation_list" name="salutation_list" class="select_id" onChange="kdbUpdateForm(this, 'SalutationUI');" size="10">
    <option value="-1"><?= _("New salutation") ?></option>
<?php
    $salutations = static::readList($DB);
    foreach ($salutations as $salutation)
      echo "    <option value=\"{$salutation['id']}\">{$salutation['name']}</option>\n";
?>
  </select>
</p>

<input type="hidden" id="salutation_id" name="salutation_id" class="id" value="<?= $this->data->salutation_id ?>">

<p>
  <label for="salutation" class="required"><?=_("Salutation")?>:</label>
  <input type="text" id="salutation" name="salutation" value="<?=$this->data->salutation?>" class="required">
</p>

<div class="form_controls_bottom">
<p>
  <input class="indented" type="submit" id="kdb_save" name="kdb_save" value="<?=_("Save")?>" onClick="kdbSaveEntry('SalutationUI', 'save'); return false;">
  <input type="submit" id="kdb_save_as" name="kdb_save_as" value="<?=_("Save as new")?>" onClick="kdbSaveEntry('SalutationUI', 'saveasnew'); return false;">
  <input type="submit" id="kdb_delete" name="kdb_delete" value="<?=_("Delete")?>" onClick="kdbDeleteEntry('SalutationUI'); return false;">
</p>
</div>
</form>
<?php
  }
}

?>