<?php
require_once("cwfUI.inc.php");
require_once(PCG_PATH."PCGCharacter.inc.php");
require_once(PCG_PATH."fpdf.php");
require_once(PCG_PATH."fpdf_bookmark.php");

$PLUGIN_CLASS="PCGCharacterUI";
error_reporting (E_ALL ^ E_NOTICE);
//error_reporting(E_ERROR | E_PARSE);

class PCGCharacterUI extends cwfUI {
  protected static $accessRight = "";
  protected static $dataClass = "PCGCharacter";
  
  protected $readonly;
  protected $lernmethode;
  
  protected $data;
  protected $error;
  protected $DB;
  protected $tooltips;
  
  static public function addKDbViewButtons() {
    return array(
      array(
        'buttonname' => 'pcg_getpdf',
        'buttontext' => ' ',
        'buttonicon' => CWF_HTTP_PATH.'plugins/pcg2/img/pdf.png',
        'buttontooltip' => 'Charaktere herunterladen'
      ),
      array(
        'buttonname' => 'pcg_getimg',
        'buttontext' => ' ',
        'buttonicon' => CWF_HTTP_PATH.'k_db/img/icons/download.png',
        'buttontooltip' => 'Bilder/Zinken herunterladen'
      )
    );
  }
  
  static public function mergeUsers($DB, $ids, $withId) {
    if(!is_array($ids) || !preg_match('~^[0-9]+$~', $withId)) return array(1, "");
    foreach($ids as $value) if(!is_numeric($value)) return array(1, "");
    
    if(in_array($withId, $ids)) $ids = array_diff($ids, array($withId));
    
    $DB->query("UPDATE pcg_charaktere SET user_id='{$withId}' WHERE user_id IN ('".implode("', '", $ids)."')");
  }
  
  public function __construct(&$DB, PCGCharacter $character=null) {
    parent::__construct();
    
    $this->DB = &$DB;
    $this->lernmethode = 1;
    $this->tooltips = array();

    $this->title = "Charakterverwaltung";
    $this->header .= '  <script src="'.PCG_HTTP_PATH.'js/main.js" type="text/javascript"></script>'."\n";
    $this->header .= '  <script type="text/javascript">var PCG_HTTP_Path="'.PCG_HTTP_PATH.'"</script>'."\n";
    $this->header .= '  <link rel="stylesheet" href="'.PCG_HTTP_PATH.'css/main.css" type="text/css">'."\n";
    
    // Charakter laden
    if(isset($_GET['charakter_id'])) {
      unset($_SESSION['pcg_charakter']);
      $this->data = new PCGCharacter();
      $this->loadChar();
    }
    else if(isset($_SESSION['pcg_charakter']))
      $this->data = unserialize($_SESSION['pcg_charakter']);
    else if($character)
      $this->data = $character;
    else {
      $this->data = new PCGCharacter();
    }
    //if ((!isset($_POST['pcg_getpdf']) && !isset($_POST['pcg_getimg'])) || !isset($_SESSION['admin']))
    //  $this->loadChar();
    
    $this->error="";
    if(isset($_SESSION['admin']))
      $this->readonly = 1;
    else {
      $this->readonly = 0;
      if(!isset($_SESSION['pcg_charakter']))
        $_SESSION['pcg_charakter'] = serialize($this->data);
    }
    
    
    /* ////////////////////////////////////////////////////////////////// */
    /* PDF / ZIP */ 
    
    if (isset($_POST['pcg_submit'])) {
      $this->data->fromArray($_POST);
      list($pcg_error, $pcg_error_txt) = $this->data->writeData($this->DB);
      $_SESSION['pcg_charakter'] = serialize($this->data);
    }
    else if (isset($_POST['pcg_getpdf'])) {
      if(isset($_SESSION['admin']) && isset($_POST['select_user_id'])) {
        $pdf = new PDF_Bookmark('P','mm','A4');
        $pdf->SetDisplayMode("real", "continuous");
        $pdf->SetMargins(20,20);
        foreach($_POST['select_user_id'] as $booking_id=>$user_id) {
          $this->data = new PCGCharacter();
          $this->loadChar($booking_id);
          if($this->data->charakter_id) {
            $pdf->AddPage();
            $charakterName = $this->data->charakter_name;
            CWFTools::decodeHTMLChars($charakterName);
            $pdf->BookmarkUTF8($charakterName);
            $pdf = $this->generate_pdf($pdf);
          }
        }
        $pdf->Output(CWFTools::sanitizeFileName($_SESSION['event']->event_name.".pdf"), 'D');
        exit;
      }
      else {
        $pdf = new FPDF('P','mm','A4');
        $pdf->SetDisplayMode("real", "continuous");
        $pdf->SetMargins(20,20);
        
        $pdf->AddPage();
        $pdf = $this->generate_pdf($pdf);
        
        $pdf->Output(CWFTools::sanitizeFileName($this->data->charakter_name.".pdf"), 'D');
        exit;
      }
    }
    else if (isset($_POST['pcg_getimg'])) {
      if(isset($_SESSION['admin'])) {
        require_once(CWF_PATH."/k_db/zipfile.inc.php");
        $path = PCG_PATH."upload";
        $downloadZip = new zip_file($path."/k_db_uploads.zip");
        $downloadZip->set_options(array('basedir'=>$path,'overwrite'=>1,'level'=>3,'inmemory'=>1,'recurse'=>1));
        
        foreach($_POST['select_user_id'] as $booking_id=>$user_id) {
          $this->data = new PCGCharacter();
          $this->loadChar($booking_id);
          if($this->data->charakter_id) {
            if ($this->data->charakter_bild) {
              $filename = "{$this->data->player_familyname}_{$this->data->charakter_name}_bild.".substr(strrchr($this->data->charakter_bild, "."), 1);
              $filename = utf8_decode(preg_replace('/[^.a-zA-Z0-9ÄÖÜäöüß_-]/u', '', $filename));
              $downloadZip->add_files($this->data->charakter_bild, array('/^'.$this->data->charakter_bild.'/'), array("{$filename}"));
            }
            if ($this->data->diebeszinken) {
              $filename = "{$this->data->player_familyname}_{$this->data->charakter_name}_zinken.".substr(strrchr($this->data->diebeszinken, "."), 1);
              $filename = utf8_decode(preg_replace('/[^.a-zA-Z0-9ÄÖÜäöüß_-]/u', '', $filename));
              $downloadZip->add_files($this->data->diebeszinken, array('/^'.$this->data->diebeszinken.'/'), array("{$filename}"));
            }
          }
        }
        $downloadZip->create_zip();
        $downloadZip->download_file();
        exit;        
      }
    }
  }

  private function loadChar($booking_id=0) {
    if($booking_id && isset($_SESSION['admin']) && isset($_SESSION['event'])) {
      $this->data->readData($this->DB, "charakter_id IN (SELECT pcr.charakter_id ".
          "FROM pcg_reg pcr ".
            "JOIN user_booking ub ON ub.booking_id=pcr.booking_id ".
          "WHERE ub.event_id={$_SESSION['event']->event_id} ".
            "AND pcr.booking_id={$booking_id} ".
            "AND pcr.end_char_view>=NOW())");
    }
    else if(isset($_GET['charakter_id']) && preg_match("~^[0-9]+$~", $_GET['charakter_id'])) {
      if(isset($_SESSION['admin']) && isset($_SESSION['event'])) {
        $this->data->readData($this->DB, "charakter_id={$_GET['charakter_id']} AND ".
                                   "EXISTS (SELECT * ".
                                           "FROM pcg_reg pcr ".
                                             "JOIN user_booking ub ON ub.booking_id=pcr.booking_id ".
                                           "WHERE ub.event_id={$_SESSION['event']->event_id} ".
                                             "AND pcr.charakter_id=pc.charakter_id ".
                                             "AND pcr.end_char_view>=NOW())");
      }
      else if(isset($_SESSION['user']))
        $this->data->readData($this->DB, "charakter_id={$_GET['charakter_id']} AND user_id={$_SESSION['user']->user_id}");
      else
        die("Charakter nicht freigegeben.");
    }
    
    $this->data->initNewChar($this->DB);
    $this->data->verlaufProzessieren();
  }
  
  static public function getValidationRules() {
    return parent::getValidationRules();
  }
  
  public function isValid() {
    return true;
  }
  
  private function replacePCGMain($mitVerlauf=true) {
    $xml = "  <replaceHTMLElement id=\"#pcg_main\"><![CDATA[\n";
    ob_start();
    $this->getHTMLPCGMain();
    $xml .= ob_get_contents();
    ob_end_clean(); 
    $xml .= "]]>\n";
    $xml .= "  </replaceHTMLElement>\n";
    if($mitVerlauf) {
      $xml .= "  <replaceHTMLElement id=\"#pcg_verlauf ul\"><![CDATA[\n";
      $xml .= $this->getVerlauf();
      $xml .= "]]>\n";
      $xml .= "  </replaceHTMLElement>\n";
    }
    return $xml;
  }
  
  public function getPostBackXML(DbConnection $DB, $action) {
    $xml = "";
    switch ($action) {
      case "lernmethode":
        if(!preg_match("~^[0-9]+$~", $_POST['lernmethode'])) return $xml;
        
        $this->lernmethode = $_POST['lernmethode'];
        $xml = "  <replaceHTMLElement id=\"#dialog_pcg_tabs\"><![CDATA[\n";
        $xml .= $this->getHTMLDialogPCG();
        $xml .= "]]>\n";
        $xml .= "  </replaceHTMLElement>\n";
        break;
      case "getImmunityDialog":
        if(!preg_match("~^[0-9]+$~", $_POST['lernmethode'])) return $xml;
        $this->lernmethode = $_POST['lernmethode'];
        $xml = "  <replaceHTMLElement id=\"#dialog_immunitaet .dialog\"><![CDATA[\n";
        $xml .= $this->getImmunityDialog($_POST['typ']);
        $xml .= "]]>\n";
        $xml .= "  </replaceHTMLElement>\n";
        break;
      case "undo":
        if($this->data->undoLastAction($this->DB)) {
          $xml = $this->replacePCGMain();
        }
        break;
      case "chooseSkill":
        if(isset($_POST['rasse']) && preg_match('~^[0-9]+$~', $_POST['rasse'])) {
          if($this->data->isNewChar()) {
            $this->data->initNewChar($this->DB, $_POST['rasse']);
            $this->data->verlaufProzessieren(true);
          }
          else
            $this->data->rasse_id = $_POST['rasse'];
          $xml = $this->replacePCGMain();
        }
        else if(isset($_POST['spiele_ep'])) {
          $newChar = $this->data->isNewChar();
          foreach ($_POST['spiele_ep'] as $spielId => $ep) {
            $this->data->setSpiel($spielId, $_POST['spiele'][$spielId], $ep);
            break;
          }
          if($newChar != $this->data->isNewChar()) {
            $xml .= $this->replacePCGMain(false);
            if($this->data->isNewChar())
              $xml .= "  <display id=\"#modus_new\" action=\"show\" />\n  <display id=\"#modus_add\" action=\"hide\" />\n";
            else
              $xml .= "  <display id=\"#modus_add\" action=\"show\" />\n  <display id=\"#modus_new\" action=\"hide\" />\n";
          }
          else if(!$_POST['spiele_ep'][$spielId] && !$_POST['spiele'][$spielId]) {
            $xml .= "  <replaceHTMLElement id=\"#dialog_spiele\"><![CDATA[\n";
            $xml .= $this->getDialogSpiele();
            $xml .= "]]>\n";
            $xml .= "  </replaceHTMLElement>\n";
          }
        }
        else if(isset($_POST['lp'])) {
          if(list($fertigkeit, $lernmethode) = $this->data->addSkill('LP', $_POST['lp'], $_POST['lernmethode'])) {
            $xml .= "  <replaceHTMLElement id=\"#pcg_main select#lp\"><![CDATA[\n";
            $xml .= $this->getLPList();
            $xml .= "]]>\n";
            $xml .= "  </replaceHTMLElement>\n";
            $xml .= "  <appendHTMLElement id=\"#pcg_verlauf ul\"><![CDATA[\n";
            $xml .= $this->getVerlaufEntry(end($this->data->verlauf), array('ep'=>$fertigkeit['ep']));
            $xml .= "]]>\n";
            $xml .= "  </appendHTMLElement>\n";
          }
        }
        else if(isset($_POST['mp']) || isset($_POST['cp']) || isset($_POST['sp'])) {
          if(isset($_POST['mp'])) $fertigkeitId = "mp";
          else if(isset($_POST['cp'])) $fertigkeitId = "cp";
          else if(isset($_POST['sp'])) $fertigkeitId = "sp";
          list($fertigkeit, $lernmethode) = $this->data->addSkill($fertigkeitId, $_POST[$fertigkeitId], $_POST['lernmethode']);
          $xml .= "  <appendHTMLElement id=\"#pcg_verlauf ul\"><![CDATA[\n";
          $xml .= $this->getVerlaufEntry(end($this->data->verlauf), array('ep'=>$fertigkeit['ep']));
          $xml .= "]]>\n";
          $xml .= "  </appendHTMLElement>\n";
        }
        else if(isset($_POST['gottheit'])) {
          $this->data->gottheit_id = $_POST['gottheit'];
          $xml .= "  <replaceHTMLElement id=\"#toggle_klerikalmagie\"><![CDATA[\n";
          $xml .= $this->formularElement("Klerikalmagie");
          $xml .= "]]>\n";
          $xml .= "  </replaceHTMLElement>\n";
          $fertigkeiten = $this->DB->query("SELECT f.fertigkeit_id, f.fertigkeit, fe.ep, f.voraussetzungen, k.kategorie, f.max_stufe ".
                                           "FROM pcg2_fertigkeiten f ".
                                           "  JOIN pcg2_fertigkeiten_ep fe ON (fe.fertigkeit_id=f.fertigkeit_id AND fe.rasse_id='{$this->data->rasse_id}') ".
                                           "  JOIN pcg2_kategorien k ON (k.kategorie_id=f.kategorie_id) ".
                                           "WHERE f.voraussetzungen LIKE '%\$g%'".
                                           "  AND kategorie <> 'Klerikalmagie' ".
                                           ($this->data->isNewChar() ? "  AND fe.ep <= {$this->data->ep_rest} " : "").
                                           "  AND fe.ep >= 0;");
          while ($fertigkeit=$DB->fetch_array($fertigkeiten))
            $xml .= "  <changeClass id=\".toggle_available #fid_{$fertigkeit['fertigkeit_id']}\">{$this->getClass($fertigkeit)}</changeClass>\n";
        }
        else if(isset($_POST['stand'])) {
          if(preg_match('~^[0-9]+$~', $_POST['stand'])) {
            $this->data->stand_id = $_POST['stand'];
          } 
        }
        else if(isset($_POST['fertigkeit'])) {
          $oldXP = $this->data->ep_rest;
          
          $fertigkeitId = array_pop($_POST['fertigkeit']);
          $verlaufCount = count($this->data->verlauf);
          //Update Toggle und Verlauf
          if(preg_match('~^[0-9]+$~', $fertigkeitId)) {
            $addSkillId = $fertigkeitId;
            $addSkillInc = $_POST['inc'];
          }
          else if(preg_match('~^i_[0-9]+$~', $fertigkeitId)) {
            $typen = array("gift"=>96, "zauber"=>120);
            if(isset($_POST['immunitaet_typ'])) {
              $addSkillId = $typen[$_POST['immunitaet_typ']];
              $addSkillInc = substr($fertigkeitId, 2);
            }
            else if ($_POST['inc']<0) {
              $addSkillId = $fertigkeitId;
              $addSkillInc = $_POST['inc'];
            }
          }
          if(list($fertigkeit, $lernmethode) = $this->data->addSkill($addSkillId, $addSkillInc, $_POST['lernmethode'])) {
            $fArray = array_merge($fertigkeit, array("toggle_id"=>0));
            if($this->data->isNewChar() && $_POST['inc']<0 && count($this->data->verlauf)<$verlaufCount-1)
              $xml .= $this->replacePCGMain();
            else {
              if($this->data->isNewChar() && $_POST['inc']<0) {
                if(count($this->data->verlauf)<$verlaufCount-1)
                  $xml .= $this->replacePCGMain();
                else {
                  $xml .= "  <replaceHTMLElement id=\"#pcg_verlauf ul\"><![CDATA[\n";
                  $xml .= $this->getVerlauf();
                  $xml .= "]]>\n";
                  $xml .= "  </replaceHTMLElement>\n";
                }
              }
              else {
                $xml .= "  <appendHTMLElement id=\"#pcg_verlauf ul\"><![CDATA[\n";
                $xml .= $this->getVerlaufEntry(end($this->data->verlauf), 
                    $this->data->f_auswahl[$fertigkeit['fertigkeit_id']]['stufe']+($_POST['inc']<0 ? 1 : 0));
                $xml .= "]]>\n";
                $xml .= "  </appendHTMLElement>\n";
              }
              
              $xml .= "  <updateToggle id=\"fid_{$fertigkeitId}\" toggle=\"toggle_".strtolower(str_replace(array(" ", "ß"), array("_", "ss"), $fArray['kategorie']))."\" ".
                                     "action=\"$action\">\n";
              if(preg_match('~^[0-9]+$~', $fertigkeitId)) {
                $xml .= "    <available><![CDATA[\n";
                $fArrayAvailable = $fArray;
                $fArrayAvailable['ep'] = $fArrayAvailable['ep_soll'];
                $xml .= $this->getListEntry($fArrayAvailable, true);
                $xml .= "]]>\n";
                $xml .= "    </available>\n";
              }
              if(isset($this->data->f_auswahl[$fertigkeitId]) && $this->data->f_auswahl[$fertigkeitId]['stufe']) {
                $xml .= "    <selected><![CDATA[\n";
                $xml .= $this->getListEntry($fArray, false);
                $xml .= "]]>\n";
                $xml .= "    </selected>\n";
              }
              $xml .= "  </updateToggle>\n";
            }
          }
          //Ende Update Toggle und Verlauf
          
          //Nicht mehr genug EP?
          if($this->data->isNewChar()) {
            if($oldXP<$this->data->ep_rest) {
              $currEP = $oldXP;
              $oldXP = $this->data->ep_rest;
            }
            else
              $currEP = $this->data->ep_rest;
            $fertigkeiten = $this->DB->query("SELECT f.fertigkeit_id, f.fertigkeit, fe.ep, f.max_stufe, k.kategorie, f.max_stufe ".
                                             "FROM pcg2_fertigkeiten f ".
                                             "  JOIN pcg2_fertigkeiten_ep fe ON (fe.fertigkeit_id=f.fertigkeit_id AND fe.rasse_id='{$this->data->rasse_id}') ".
                                             "  JOIN pcg2_kategorien k ON (k.kategorie_id=f.kategorie_id) ".
                                             "WHERE k.kategorie <> 'Nachteil' ".
                                             "  AND fe.ep > {$currEP} ".
                                             "  AND fe.ep <= {$oldXP};");
            while ($fertigkeit=$DB->fetch_array($fertigkeiten))
              $xml .= "  <changeClass id=\".toggle_available #fid_{$fertigkeit['fertigkeit_id']}\">{$this->getClass($fertigkeit)}</changeClass>\n";
          }
          //geänderte Voraussetzungen
          $fertigkeiten = $this->DB->query("SELECT f.fertigkeit_id, f.fertigkeit, fe.ep, f.voraussetzungen, k.kategorie, f.max_stufe ".
                                           "FROM pcg2_fertigkeiten f ".
                                           "  JOIN pcg2_fertigkeiten_ep fe ON (fe.fertigkeit_id=f.fertigkeit_id AND fe.rasse_id='{$this->data->rasse_id}') ".
                                           "  JOIN pcg2_kategorien k ON (k.kategorie_id=f.kategorie_id) ".
                                           "WHERE f.voraussetzungen LIKE '%\'{$fertigkeitId}\'%'".
                                           ($this->data->isNewChar() ? "  AND fe.ep <= {$this->data->ep_rest} " : "").
                                           "  AND fe.ep >= 0;");
          while ($fertigkeit=$DB->fetch_array($fertigkeiten))
            $xml .= "  <changeClass id=\".toggle_available #fid_{$fertigkeit['fertigkeit_id']}\">{$this->getClass($fertigkeit)}</changeClass>\n";
          
          //Besondere Aktionen
          $refreshMCSP = "";
          if($this->data->hasMCSPoints("mp", $fertigkeitId)) $refreshMCSP = "mp";
          if($this->data->hasMCSPoints("cp", $fertigkeitId)) $refreshMCSP = "cp";
          if($this->data->hasMCSPoints("sp", $fertigkeitId)) $refreshMCSP = "sp";
          if($refreshMCSP) {
            $xml .= "  <replaceHTMLElement id=\"#container_{$refreshMCSP}\"><![CDATA[\n";
            $xml .= $this->getMCSPElement($refreshMCSP);
            $xml .= "]]>\n";
            $xml .= "  </replaceHTMLElement>\n";
          }
          if($fertigkeitId==2) {  //Ausgezehrt
            $xml .= "  <replaceHTMLElement id=\"#pcg_main select#lp\"><![CDATA[\n";
            $xml .= $this->getLPList();
            $xml .= "]]>\n";
            $xml .= "  </replaceHTMLElement>\n";
          }
          if(in_array($fertigkeitId, array(127, 126, 132, 135, 133, 134, 131, 124, 88, 106))) {
            $magie = array(
              127=>"Klerikalmagie", 126=>"Bardenmagie", 132=>"Schamanismus", 135=>"Zauberei",
              133=>"Schwarze Magie", 134=>"Weiße Magie", 131=>"Runenmagie", 124=>"Artefaktmagie",
              88=>"Alchemie", 106=>"Pharmazie"
            );
            if(isset($this->data->f_auswahl[$fertigkeitId]))
              $jsAktion = "show";
            else
              $jsAktion = "hide";
            $xml .= "  <display id=\"#toggle_".strtolower(str_replace(array(" ", "ß"), array("_", "ss"), $magie[$fertigkeitId]))."\" action=\"{$jsAktion}\" />\n";
          }
        }
        break;
      case "delete":
        if(isset($_POST['setDead']) && $_POST['setDead']) {
          $this->data->deleteData($this->DB, $this->data->charakter_id, true);
          $this->data->ist_tot = abs($this->data->ist_tot - 1);
          $xml .= "  <replaceHTMLElement id=\"#pcg_death\"><![CDATA[\n";
          if($this->data->ist_tot)
            $xml .= "<input type=\"submit\" id=\"pcg_death\" name=\"pcg_revive\" value=\"Wiederbeleben\" onClick=\"pcgDeleteChar(1); return false;\">\n";
          else
            $xml .= "<input type=\"submit\" id=\"pcg_death\" name=\"pcg_dead\" value=\"Tot\" onClick=\"pcgDeleteChar(1); return false;\">\n";
          $xml .= "]]>\n";
          $xml .= "  </replaceHTMLElement>\n";
          
        }
        else {
          $this->data->deleteData($this->DB, $this->data->charakter_id);
          $this->data = new PCGCharacter();
          $this->data->initNewChar($this->DB);
          $this->data->verlaufProzessieren();
          unset($_SESSION['pcg_charakter']);
          $_SESSION['pcg_charakter'] = serialize($this->data);
          $xml .= $this->replacePCGMain();
        }
      case "save":
        $menu = new MainRegUI($this->DB);
        $xml .= "  <replaceHTMLElement id=\"#menu ul#dropdownmenu li#menuitem_pcg.submenu ul\"><![CDATA[\n";
        $xml .= "<ul>\n";
        $xml .= $menu->getMenuPublic("pcg", PCGCharacter::getMenuArray());
        $xml .= "</ul>\n";
        $xml .= "]]>\n";
        $xml .= "  </replaceHTMLElement>\n";
        unset($menu);
        break;
    }
    $xml .= "  <newValues>\n";
    if(in_array($action, array("save", "delete")))
      $xml .= "    <newValue name=\"charakter_name\">{$this->data->charakter_name}</newValue>\n";
    $xml .= "    <newValue name=\"ep_gesamt\">{$this->data->ep_gesamt}</newValue>\n";
    $xml .= "    <newValue name=\"ep_rest\">{$this->data->ep_rest}</newValue>\n";
    $xml .= "  </newValues>\n";
    $_SESSION['pcg_charakter'] = serialize($this->data);
    return $xml;
  }

  static public function isAllowedAction($action) {
    return in_array($action, array("chooseSkill", "undo", "save", "lernmethode", "getImmunityDialog", "delete"));
  }
  
  public function doAction(DbConnection $DB, $action) {
    $id = "";
    switch ($action) {
      case "save":
        $this->saveForm($DB);
        $id = $this->getId();
        break;
    }
    return $id;
  }
  
  ///////////////////////////////////////////////////////////////////////////////
  // Output
  //

  private function getSkillName($fertigkeit, $isAvailable=true) {
    if ($fertigkeit['ep']<0)
      return "{$fertigkeit['fertigkeit']}";
    
    if($isAvailable)
      $ep = ($fertigkeit['ep']*(($fertigkeit['kategorie']!="Nachteil") ? $this->lernmethode : 1));
    else if(isset($fertigkeit['stufe']))
      $ep = $fertigkeit['ep'];
    else
      $ep = array_sum($this->data->f_auswahl[$fertigkeit['fertigkeit_id']]['ep']);
    if ($fertigkeit['max_stufe']>1) {
      if(isset($fertigkeit['stufe']))
        return "{$fertigkeit['fertigkeit']} ".
               ($fertigkeit['stufe'] + ($isAvailable ? 1 : 0)).
               " ({$ep})";
      else
        return "{$fertigkeit['fertigkeit']} ".
               (!isset($this->data->f_auswahl[$fertigkeit['fertigkeit_id']]) ? 
                   1 : 
                   $this->data->f_auswahl[$fertigkeit['fertigkeit_id']]['stufe'] + ($isAvailable ? 1 : 0)).
               " ({$ep})";
    }
    else
      return "{$fertigkeit['fertigkeit']} ({$ep})";
  }
  
  private function getClass($fertigkeit, $isAvailable=true) {
    if($isAvailable) {
      if(isset($this->data->f_auswahl[$fertigkeit['fertigkeit_id']]) && $this->data->f_auswahl[$fertigkeit['fertigkeit_id']]['stufe']>=$fertigkeit['max_stufe'])
        $class = "maxed_out";
      else if($fertigkeit['ep']<0)
        $class = "not_available";
      else if(!$this->data->checkPrerequisites($fertigkeit['voraussetzungen']))
        $class = "prereq";
      else if ($this->data->isNewChar() && $fertigkeit['ep']>$this->data->ep_rest && $fertigkeit['kategorie']!="Nachteil")
        $class = "no_ep";
      else
        $class = "available";
      
      return $class;
    }
    else
      return "available";
  }
  
  private function getListEntry($fertigkeit, $isAvailable=true) {
    if($isAvailable) {
      $class = $this->getClass($fertigkeit, $isAvailable);
      $str = "";
      if($fertigkeit['voraussetzungen_text'])
        $this->tooltips[] =  "<span id=\"tt_fid_{$fertigkeit['fertigkeit_id']}\" class=\"tooltip\">Voraussetzungen: {$fertigkeit['voraussetzungen_text']}</span>\n";
      $str .= "          <li class=\"{$class}\" id=\"fid_{$fertigkeit['fertigkeit_id']}\" name=\"toggle_{$fertigkeit['toggle_id']}\">".$this->getSkillName($fertigkeit);
    }
    else {
      $str = "          <li class=\"available\" id=\"fid_{$fertigkeit['fertigkeit_id']}_a\" name=\"toggle_{$fertigkeit['toggle_id']}\">".$this->getSkillName($fertigkeit, false);
    }
    $str .= "<input type=\"hidden\" name=\"fertigkeit[]\" value=\"{$fertigkeit['fertigkeit_id']}\"></li>\n";
    
    return $str;
  }
  
  private function getImmunityList($epMulti, $kategorie, $unterkategorie=null) {
    $str = "";
    $fertigkeiten = $this->DB->query("SELECT f.*, k.kategorie, uk.kategorie unterkategorie, fe.ep ".
                                     "FROM pcg2_fertigkeiten f ".
                                     "  JOIN pcg2_fertigkeiten_ep fe ON (fe.fertigkeit_id=f.fertigkeit_id AND fe.rasse_id='{$this->data->rasse_id}') ".
                                     "  JOIN pcg2_kategorien k ON (k.kategorie_id=f.kategorie_id) ".
                                     "  LEFT JOIN pcg2_kategorien uk ON (uk.kategorie_id=f.unterkategorie_id) ".
                                     "WHERE k.kategorie".(is_array($kategorie) ? " IN ('".implode("','", $kategorie)."')" : "='{$kategorie}'")." ".
                                     ($unterkategorie ? "  AND uk.kategorie IN ('{$unterkategorie}') " : "").
                                     "ORDER BY f.kategorie_id, f.fertigkeit;");
    $str .= "  <div class=\"toggle\">
    <div class=\"toggle_part toggle_list\">
      <div></div>
        <ul>\n";
    $currKategorie = "keine";
    while ($fertigkeit = $this->DB->fetch_array($fertigkeiten)) {
      if(!$unterkategorie && $currKategorie!=$fertigkeit['kategorie']) {
        $str .= "      <li name=\"toggle_".(++$counter)."\" class=\"toggle_header\">{$fertigkeit['kategorie']}</li>\n";
        $currKategorie = $fertigkeit['kategorie'];
      }
      $fertigkeit['fertigkeit_id'] = "i_".$fertigkeit['fertigkeit_id'];
      $fertigkeit['toggle_id'] = $fertigkeit['fertigkeit_id'];
      $fertigkeit['max_stufe'] = 1;
      $fertigkeit['voraussetzungen'] = "";
      $fertigkeit['voraussetzungen_text'] = "";
      $fertigkeit['ep'] = $fertigkeit['ep']*$epMulti;
      //if(isset($this->data->f_auswahl[$fertigkeit['fertigkeit_id']]) && $this->data->f_auswahl[$fertigkeit['fertigkeit_id']]['stufe']>0)
        $str .= $this->getListEntry($fertigkeit, true);
    }
    $str .= "        </ul>
    </div>
  </div>\n";
    
    return $str;
  }
  
  private function formularElement($kategorie, $disable=false) {
    $str = "";
    
    switch ($kategorie) {
      case "Nachteil": $header = "Nachteile"; break;
      case "Allgemein": $header = "allgemeine Fertigkeiten"; break;
      case "Kampf": $header = "Kampffertigkeiten"; break;
      case "Magie": $header = "Magiefertigkeiten"; break;
      default:
        $header = $kategorie;
    }
    
    $fertigkeiten = $this->DB->query("SELECT f.*, k.kategorie, uk.kategorie unterkategorie, fe.ep ".
                                     "FROM pcg2_fertigkeiten f ".
                                     "  JOIN pcg2_fertigkeiten_ep fe ON (fe.fertigkeit_id=f.fertigkeit_id AND fe.rasse_id='{$this->data->rasse_id}') ".
                                     "  JOIN pcg2_kategorien k ON (k.kategorie_id=f.kategorie_id) ".
                                     "  LEFT JOIN pcg2_kategorien uk ON (uk.kategorie_id=f.unterkategorie_id) ".
                                     "WHERE k.kategorie='{$kategorie}' ".
                                     ($kategorie=="Klerikalmagie" ? "  AND f.voraussetzungen REGEXP 'in_array[(][^)]*{$this->data->gottheit_id}[^)]*[)]' " : "").
                                     "ORDER BY f.unterkategorie_id, f.fertigkeit;");
    $str .= "    <div class=\"toggle\" id=\"toggle_".strtolower(str_replace(array(" ", "ß"), array("_", "ss"), $kategorie))."\"".($disable ? " style=\"display:none;\"" : "").">\n";
    if(!$this->readonly) {
      $str .= "      <div class=\"toggle_part toggle_available\">
        <div>Verfügbare {$header}:</div>
        <ul>\n";
      $selected = array();
      $unterKategorie = "keine";
      $counter = 0;
      while ($fertigkeit = $this->DB->fetch_array($fertigkeiten)) {
        if($fertigkeit['unterkategorie'] && $unterKategorie!=$fertigkeit['unterkategorie']) {
          $str .= "          <li name=\"toggle_".(++$counter)."\" class=\"toggle_header\">{$fertigkeit['unterkategorie']}</li>\n";
          $unterKategorie = $fertigkeit['unterkategorie'];
        }
        $fertigkeit['toggle_id'] = ++$counter;
        $str .= $this->getListEntry($fertigkeit);
        if(in_array($fertigkeit['fertigkeit_id'], array(96, 120))) {
          foreach($this->data->f_auswahl as $fid => $f)
            if(isset($f['immunitaet']) && $f['immunitaet']==$fertigkeit['fertigkeit_id']) { $f['fertigkeit_id'] = $fid; $f['ep'] = array_sum($f['ep']); $selected[] = $f; }
        }
        else if(isset($this->data->f_auswahl[$fertigkeit['fertigkeit_id']]) && $this->data->f_auswahl[$fertigkeit['fertigkeit_id']]['stufe']>0)
          $selected[] = $fertigkeit;
      }
      $str .= "        </ul>
      </div><div class=\"toggle_control\"><span class=\"toggle_add\">&raquo;</span><br><span class=\"toggle_remove\">&laquo;</span></div><div class=\"toggle_part toggle_selected\">\n";
    }
    else {
      $selected = array();
      while ($fertigkeit = $this->DB->fetch_array($fertigkeiten)) {
        $fertigkeit['toggle_id'] = $fertigkeit['fertigkeit_id'];
        if(isset($this->data->f_auswahl[$fertigkeit['fertigkeit_id']]) && $this->data->f_auswahl[$fertigkeit['fertigkeit_id']]['stufe']>0)
          $selected[] = $fertigkeit;
      }
      $str .= "    <div class=\"toggle_part toggle_list\">\n";
    }
    
    $str .= "        <div>Ausgewählte {$header}:</div>
        <ul>\n";
    foreach ($selected as $fertigkeit) {
      $str .= $this->getListEntry($fertigkeit, false);
    }
    $str .= "        </ul>
      </div>
    </div>\n";
        
    return $str;
  }
  
  private function getLPList() {
    $readonly = "";
    if($this->data->isNewChar()) $readonly = " disabled";
    if($this->readonly)
      $str = "      <input type=\"text\" id=\"lp\" name=\"lp\" value=\"{$this->data->lp}\" readonly>\n";
    else {
      $str = "      <select id=\"lp\" name=\"lp\"{$readonly}>\n";
      for ($lp=1; $lp<=$this->DB->result($this->DB->query("SELECT lp_max FROM pcg2_rassen WHERE rasse_id='{$this->data->rasse_id}'"), 0, 0); $lp++)
        if ($lp > $this->data->lp)
          $str .= "        <option value=\"$lp\"".(($this->data->lp==$lp) ? " selected" : "").">{$lp} (".$this->data->getXPforLP($lp, $this->lernmethode, $this->data->lp).")</option>\n";
        else
          $str .= "        <option value=\"$lp\"".(($this->data->lp==$lp) ? " selected" : "").">{$lp}</option>\n";
  
      $str .= "      </select>\n";
    }
    return $str;
  }
  
  private function getMCSPElement($element) {
    $readonly = "";
    if($this->data->isNewChar()) $readonly = " disabled";
    if(!$this->data->hasMCSPoints($element))  $readonly = " disabled";
    if($this->readonly) $readonly = " readonly";
    $str .= "    <p id=\"container_{$element}\">
      <label for=\"{$element}\">".strtoupper($element).":</label>
      <input type=\"text\" id=\"{$element}\" name=\"{$element}\" value=\"{$this->data->$element}\"{$readonly}>
    </p>\n";
    
    return $str;
  }
  
  private function getVerlaufEntry($aktion, $stufe="") {
    $class = array();
    switch ($aktion['lm']) {
      case 0:
        $class[] = "lm_0";
        break;
      case 2:
        $class[] = "lm_2";
        break;
    }
    if($aktion['id']=='R') return "<li>Rasse &rArr; {$aktion['name']}</li>\n";
    if(in_array($aktion['id'], array('LP', 'MP', 'CP', 'SP')))
      return "<li".((count($class)>0) ? " class=\"".implode(" ", $class)."\"" : "").">{$aktion['id']} &rArr; {$aktion['inc']} ({$aktion['ep']})</li>\n";
    
    if($aktion['inc']<0) $class[] = "skill_removed";
    $fertigkeit = $this->data->f_auswahl[$aktion['id']];
    $fertigkeit['ep'] = $aktion['ep'];
    $fertigkeit['stufe'] = $stufe;
    return "<li".((count($class)>0) ? " class=\"".implode(" ", $class)."\"" : "").">".$this->getSkillName($fertigkeit, false)."</li>\n";
  }
  
  private function getVerlauf() {
    $str = "<ul>\n";
    $stufe = array();
    foreach(array_slice($this->data->verlauf, 1) as $aktion) {
      switch($aktion['id']) {
        case 'LP':
        case 'MP':
        case 'CP':
        case 'SP':
        case 'R':
          $str .= "  ".$this->getVerlaufEntry($aktion);
          break;
        default:
          $stufe[$aktion['id']] += $aktion['inc'];
          $str .= "  ".$this->getVerlaufEntry($aktion, $stufe[$aktion['id']]);
      }
    }
    $str .= "</ul>\n";
    return $str;    
  }
  
  private function getDialogSpiele() {
    $str = "
  <div class=\"dialog\" id=\"dialog_spiele\" style=\"display:none;\">
    <h4>Besuchte Spiele</h4>
    <table class=\"alignleft\">
      <tr>
        <th>Name des Spiels</th>
        <th>EP</td>
      </tr>\n";
    foreach ($this->data->spiele as $spielId => $spiel) {
      $str .= "      <tr>\n";
      $str .= "        <td><input type=\"text\" id=\"spiele_$spielId\" name=\"spiele[$spielId]\" value=\"$spiel\" size=\"40\"".($this->readonly ? " readonly" : "")."></td>\n";
      $str .= "        <td><input type=\"text\" id=\"spiele_ep_$spielId\" name=\"spiele_ep[$spielId]\" value=\"{$this->data->spiele_ep[$spielId]}\" size=\"2\"".($this->readonly ? " readonly" : "")."></td>\n";
      $str .= "      </tr>\n";
    }
    if(!isset($spielId)) $spielId = 0; else $spielId++;
    if(!$this->readonly)
      $str .= "      <tr>
        <td><input type=\"text\" id=\"spiele_{$spielId}\" name=\"spiele[{$spielId}]\" value=\"\" size=\"40\"></td>
        <td><input type=\"text\" id=\"spiele_ep_{$spielId}\" name=\"spiele_ep[{$spielId}]\" value=\"\" size=\"2\"></td>
      </tr>\n";
    $str .= "    </table><br>
  </div>\n";
    
    return $str;
  }
  
  public function getHTMLView(DbConnection $DB) {
  }
  
  private function getHTMLDialogPCG() {
    $readonly = "";
    if($this->readonly) $readonly = " readonly";
    
    $str = "  <div id=\"dialog_pcg_tabs\">";
    //Char
    $str .= "
  <div class=\"dialog active\" id=\"dialog_char\">
    <div style=\"display: inline-block; vertical-align:top;\">
    <p>
      <label for=\"rasse\">Rasse:</label>\n";
    if($this->readonly)
      $str .= "      <input type=\"text\" id=\"rasse\" name=\"rasse\" value=\"".
              $this->DB->result($this->DB->query("SELECT rasse FROM pcg2_rassen WHERE rasse_id='{$this->data->rasse_id}';"), 0, 0)."\"{$readonly}>\n";
    else {
      $str .= "      <select id=\"rasse\" name=\"rasse\">\n";
      $str .= "        <option value=\"0\">Rasse wählen</option>\n";
      $rassen = $this->DB->query("SELECT * FROM pcg2_rassen ORDER BY rasse_id");
      while ($rasse = $this->DB->fetch_array($rassen))
        $str .= "        <option value=\"{$rasse['rasse_id']}\"".(($this->data->rasse_id==$rasse['rasse_id']) ? " selected" : "").">{$rasse['rasse']}</option>\n";
      $str .= "      </select>\n";
    }
    $str .= "    </p>
    <p>
      <label for=\"gottheit\">Religion:</label>\n";
    if($this->readonly)
      $str .= "      <input type=\"text\" id=\"gottheit\" name=\"gottheit\" value=\"".
              $this->DB->result($this->DB->query("SELECT gottheit FROM pcg2_goetter WHERE gottheit_id='{$this->data->gottheit_id}';"), 0, 0)."\"{$readonly}>\n";
    else {
      $str .= "      <select id=\"gottheit\" name=\"gottheit\">\n";
      $goetter = $this->DB->query("SELECT * FROM pcg2_goetter ORDER BY gottheit_id");
      while ($gott = $this->DB->fetch_array($goetter))
        $str .= "        <option value=\"{$gott['gottheit_id']}\"".(($this->data->gottheit_id==$gott['gottheit_id']) ? " selected" : "").">{$gott['gottheit']}</option>\n";
      $str .= "      </select>\n";
    }
    $str .= "    </p>
    <p>
      <label for=\"lp\">LP:</label>\n";
    $str .= $this->getLPList();
    $str .= "    </p>\n";
    $str .= "    <p>
      <label for=\"stand\">Stand:</label>\n";
    if($this->readonly) {
      $standTmp = $this->data->getStand($this->data->stand_id);
      $str .= "      <input type=\"text\" id=\"stand\" name=\"stand\" value=\"{$standTmp['name']}\"{$readonly}>\n";
      unset($standTmp);
    }
    else {
      $str .= "       <select name=\"stand\" id=\"stand\">\n";
      foreach($this->data->getStand() as $standId => $stand)
        if($standId==0)
          $str .= "        <option value=\"0\">nicht von Stand</option>\n";
        else
          $str .= "        <option value=\"{$standId}\"".($this->data->stand_id==$standId ? " selected" : "").">{$stand['name']} ({$stand['ep']} EP, {$stand['geld']} Silber)</option>\n";
      $str .= "      </select>\n";
    }
    $str .= "    </div>\n";
    $str .= "    <div style=\"display: inline-block; margin-left:55px;\">\n";
    $str .= $this->getMCSPElement("mp");
    $str .= $this->getMCSPElement("cp");
    $str .= $this->getMCSPElement("sp");
    $str .= "    </div>\n";
    $str .= $this->formularElement("Nachteil");

    $str .= "    <h4>Beschreibung</h4>\n";
    $str .= "    <div style=\"display: inline-block; vertical-align:top;\">
      <p>
        <label for=\"haarfarbe\">Größe:</label>\n";
    if($this->readonly)
      $str .= "        <input type=\"text\" id=\"groesse\" name=\"groesse\" value=\"{$this->data->groesse} cm\"{$readonly}>\n";
    else {
      $str .= "        <select id=\"groesse\" name=\"groesse\">\n";
      for ($i=150; $i<=220; $i=$i+5)
        $str .= "          <option value=\"$i\"".($this->data->groesse==$i ? " selected" : "").">$i cm</option>\n";
      $str .= "        </select>\n";
    }
    $str .= "      </p>
      <p>
        <label for=\"gewicht\">Gewicht:</label>\n";
    if($this->readonly)
      $str .= "        <input type=\"text\" id=\"gewicht\" name=\"gewicht\" value=\"{$this->data->gewicht} kg\"{$readonly}>\n";
    else {
      $str .= "        <select id=\"gewicht\" name=\"gewicht\">\n";
      for ($i=45; $i<=125; $i=$i+5)
        $str .= "          <option value=\"$i\"".($this->data->gewicht==$i ? " selected" : "").">$i kg</option>\n";
      $str .= "        </select>\n";
    }
    $str .= "      </p>
    </div>\n";
    $str .= "    <div style=\"display: inline-block; margin-left:55px;\">
      <p>
        <label for=\"haarfarbe\">Haarfarbe:</label>
        <input type=\"text\" id=\"haarfarbe\" name=\"haarfarbe\" value=\"{$this->data->haarfarbe}\"{$readonly}>
      </p>
      <p>
        <label for=\"augenfarbe\">Augenfarbe:</label>
        <input type=\"text\" id=\"augenfarbe\" name=\"augenfarbe\" value=\"{$this->data->augenfarbe}\"{$readonly}>
      </p>
    </div>
    <p>
      <label for=\"beruf\">Offizieller Beruf:</label>
      <input type=\"text\" id=\"beruf\" name=\"beruf\" value=\"{$this->data->beruf}\"{$readonly}>
    </p>
    <p>
      <label for=\"kleidung\">Kleidung:</label>
      <input type=\"text\" id=\"kleidung\" name=\"kleidung\" value=\"{$this->data->kleidung}\"{$readonly}>
    </p>
    <p>
      <label for=\"bes_kennzeichen\">Besondere Kennzeichen:</label>
      <input type=\"text\" id=\"bes_kennzeichen\" name=\"bes_kennzeichen\" value=\"{$this->data->bes_kennzeichen}\"{$readonly}>
    </p>\n";
    $str .= "    <h4>Herkunft</h4>
    <p>
      <label for=\"land_id\">Land:</label>\n";
    if($this->readonly)
      $str .= "      <input type=\"text\" id=\"land_id\" name=\"land_id\" value=\"".
              $this->DB->result($this->DB->query("SELECT land_name FROM pcg_laender WHERE land_id='{$this->data->land_id}';"), 0, 0)."\"{$readonly}>\n";
    else {
      $str .= "      <select id=\"land_id\" name=\"land_id\">
        <option value=\"0\">Land auswählen</option>\n";
      $pcglaender=$this->DB->query("SELECT * FROM pcg_laender ORDER BY land_name;");
      while ($pcgland=$this->DB->fetch_array($pcglaender))
        $str .= "        <option value=\"{$pcgland['land_id']}\"".($this->data->land_id==$pcgland['land_id'] ? " selected" : "").">{$pcgland['land_name']}</option>\n";
      $str .= "      </select>\n";
    }
    $str .= "    </p>
    <p>
      <label for=\"herkunft\">Stadt/Landstrich/usw.:</label>
      <input type=\"text\" id=\"herkunft\" name=\"herkunft\" value=\"{$this->data->herkunft}\"{$readonly}>
    </p>\n";
    $str .= "    <h4>Hintergrund</h4>
    <p>
      <textarea id=\"hintergrund\" name=\"hintergrund\"{$readonly}>{$this->data->hintergrund}</textarea>
    </p><br>\n";
    $str .= "  </div>";
    
    if($this->data->rasse_id) {
    //Skills
    $str .= "
  <div class=\"dialog\" id=\"dialog_skills\" style=\"display:none;\">\n";
    $str .= $this->formularElement("Allgemein");
    $str .= $this->formularElement("Kampf");
    $str .= $this->formularElement("Magie");
    $str .= "    <br>\n  </div>";

    //Spells
    $str .= "
  <div class=\"dialog\" id=\"dialog_spells\" style=\"display:none;\">\n";
    $str .= $this->formularElement("Klerikalmagie", !$this->data->hasSkill(127));
    $str .= $this->formularElement("Bardenmagie", !$this->data->hasSkill(126));
    $str .= $this->formularElement("Schamanismus", !$this->data->hasSkill(132));
    $str .= $this->formularElement("Zauberei", !$this->data->hasSkill(135));
    $str .= $this->formularElement("Schwarze Magie", !$this->data->hasSkill(133));
    $str .= $this->formularElement("Weiße Magie", !$this->data->hasSkill(134));
    $str .= $this->formularElement("Runenmagie", !$this->data->hasSkill(131));
    $str .= $this->formularElement("Artefaktmagie", !$this->data->hasSkill(124));
    $str .= $this->formularElement("Alchemie", !$this->data->hasSkill(88));
    $str .= $this->formularElement("Pharmazie", !$this->data->hasSkill(106));
    $str .= "    <br>\n  </div>\n";
    
    //Spiele
    $str .= $this->getDialogSpiele();
    }
    //Misc
    $str .= "  <div class=\"dialog\" id=\"dialog_misc\" style=\"display:none;\">\n";
    if(!$this->readonly)
      $str .= "    <div style=\"float:right; margin-left:5em; margin-right:5em;\">".
      (($this->data->charakter_bild) ? "<img src=\"".PCG_HTTP_PATH."upload/{$this->data->charakter_bild}\" alt=\"{$this->data->charakter_name}\" title=\"{$this->data->charakter_name}\">" :
                                       "&nbsp;") . "</div>
    <div>
      <h4 style=\"margin-top:0\">Bild:</h4>
      <p><input type=\"file\" name=\"datei_bild\" id=\"pcg_bild_datei\"><br>
      <input type=\"submit\" name=\"pcg_submit\" value=\"Bild hochladen\"></p>
      <p>Bilder müssen im JPEG-Format vorliegen und dürfen maximal 200 Pixel hoch und 150 Pixel breit sein. Größere Bilder werden automatisch verkleinert.</p>
    </div>
    <br clear=\"all\"><br>\n";
    else
      $str .= "    <h4>Bild:</h4>\n    <div style=\"margin-left:5em; margin-right:5em;\">".
          (($this->data->charakter_bild) ? "<img src=\"".PCG_HTTP_PATH."upload/{$this->data->charakter_bild}\" alt=\"{$this->data->charakter_name}\" title=\"{$this->data->charakter_name}\">" :
          "&nbsp;") . "</div>\n";

    if(!$this->readonly)
      $str .= "    <div style=\"float:right; margin-left:5em; margin-right:5em; width:200px; height:200px; border: 1px solid black;\">".
      (($this->data->diebeszinken) ? "<img src=\"".PCG_HTTP_PATH."upload/{$this->data->diebeszinken}\" alt=\"Diebeszinken\" title=\"Diebeszinken von {$this->data->charakter_name}\">" :
                                       "&nbsp;") . "</div>
    <div>
      <h4 style=\"margin-top:0\">Diebszinken:</h4>
      <p><input type=\"file\" name=\"datei_zinken\" id=\"pcg_zinken_datei\" size=\"40\"><br>
      <input type=\"submit\" name=\"pcg_submit\" value=\"Zinken hochladen\"></p>
      <p>Bilder müssen im JPEG-Format vorliegen und dürfen maximal 200 Pixel hoch und breit sein. Größere Bilder werden automatisch verkleinert.</p>
    </div>
    <br clear=\"all\">\n";
    else
      $str .= "    <h4>Diebszinken:</h4>\n    <div style=\"margin-left:5em; margin-right:5em; width:200px; height:200px; border: 1px solid black;\">".
      (($this->data->diebeszinken) ? "<img src=\"".PCG_HTTP_PATH."upload/{$this->data->diebeszinken}\" alt=\"{$this->data->diebeszinken}\" title=\"{$this->data->diebeszinken}\">" :
      "&nbsp;") . "</div>\n";
    
    $str .= "    <h4>Vermögen:</h4>
    <input type=\"text\" id=\"vermoegen\" name=\"vermoegen\" value=\"{$this->data->vermoegen}\"{$readonly}> Silber (jede Währung)

    <h4>Spezielle Fertigkeiten, Rezepturen, etc.:</h4>
    <textarea id=\"spez_fertigkeiten\" name=\"spez_fertigkeiten\"{$readonly}>{$this->data->spez_fertigkeiten}</textarea>
  
    <h4>Artefakte:</h4>
    <textarea id=\"artefakte\" name=\"artefakte\"{$readonly}>{$this->data->artefakte}</textarea>
    <br>&nbsp;
  </div>
  </div>\n";
    
    return $str;
  }
  
  private function getHTMLPCGMain() {
    $readonly = "";
    if($this->readonly) $readonly = " readonly";
?>
<div id="pcg_main">
  <div id="lernmethode">
<?php
    if (!$this->readonly) {
      if ($this->data->isNewChar()) {
        echo "    <input type=\"hidden\" id=\"lm_hidden\" name=\"lernmethode\" value=\"1\">\n";
        $disabled = " disabled";
      }
      else
        $disabled = "";
?>
    <input type="radio" name="lernmethode" value="1"<?=$disabled; ?><?=(($this->lernmethode==1) ? " checked" : "")?>> Lehrmeister
    <input type="radio" name="lernmethode" value="2"<?=$disabled; ?><?=(($this->lernmethode==2) ? " checked" : "")?>> Selbststudium
    <input type="radio" name="lernmethode" value="0"<?=$disabled; ?><?=(($this->lernmethode==0) ? " checked" : "")?>> Kostenlos
    <span style="position:fixed; right:10px; font-size:14px;"><a href="<?=PCG_HTTP_PATH?>hilfe.html" target="_blank">Hilfe</a></span>
<?php
    }
?>
  </div>
  
<div id="dialog_pcg" class="dialog_container">
<div class="dialog_columns">
  <div id="tab_char" class="tab active" onClick="changeTab($(this), 'dialog_char');">Charakter</div>
<?php
    if($this->data->rasse_id) {
?>
  <div id="tab_skills" class="tab" onClick="changeTab($(this), 'dialog_skills');">Fertigkeiten</div>
  <div id="tab_spells" class="tab" onClick="changeTab($(this), 'dialog_spells');">Zauber&amp;Tränke</div>
  <div id="tab_spiele" class="tab" onClick="changeTab($(this), 'dialog_spiele');">Spiele</div>
<?php
    }
?>
  <div id="tab_misc" class="tab" onClick="changeTab($(this), 'dialog_misc');">Sonstiges</div>
<?php
    echo $this->getHTMLDialogPCG();
?>
</div>
</div>
</div>
<?php
    foreach($this->tooltips as $tooltip) {
      echo $tooltip;
    }
  }
  
  private function getImmunityDialog($typ) {
    $str = "<div class=\"dialog\">\n";
    switch($typ) {
      case "gift":
        $str .= "  <h4>Giftimmunität</h4>\n";
        $str .= $this->getImmunityList($this->DB->result($this->DB->query("SELECT ep FROM pcg2_fertigkeiten_ep WHERE fertigkeit_id=96 AND rasse_id={$this->data->rasse_id};"), 0, 0),
                                       'Pharmazie', 'Gifte');
        break;
      case "zauber":
        $str .= "  <h4>Spruchimmunität</h4>\n";
        $str .= $this->getImmunityList($this->DB->result($this->DB->query("SELECT ep FROM pcg2_fertigkeiten_ep WHERE fertigkeit_id=120 AND rasse_id={$this->data->rasse_id};"), 0, 0),
                                       array('Bardenmagie', 'Klerikalmagie', 'Runenmagie', 'Schamanismus', 'Schwarze Magie', 'Weiße Magie', 'Zauberei')); 
        break;
    }
    $str .= "<input type=\"hidden\" id=\"immunitaet_typ\" name=\"immunitaet_typ\" value=\"{$typ}\">\n";
    $str .= "</div>\n";
    return $str;
  }
  
  public function getHTML(DbConnection $DB) {
    $readonly = "";
    if($this->readonly) $readonly = " readonly";
?>
<form id="kdb_form" action="" method="post" enctype="multipart/form-data">

<div id="pcg_version">Phönix Charaktergenerator <?php echo PCG_VERSION; ?></div>

<input type="hidden" name="charakter_id" value="<?=$this->data->charakter_id?>">

<div id="pcg_header">
  <div id="pcg_help">
<?php
    if (!$this->readonly) {
      echo "
      <div id=\"modus_new\" style=\"display:".($this->data->isNewChar()?"block":"none")."\">
        <p><b>Charakter-Erschaffung</b></p>
        <p>Fertigkeiten und Nachteile können beliebig hinzugefügt und gelöscht werden.
          Der Entwurfsmodus endet, sobald ein Spiel eingetragen wurde.</p>
      </div>
      <div id=\"modus_add\" style=\"display:".($this->data->isNewChar()?"none":"block")."\">
        <p><b>Charakter-Entwicklung</b></p>
        <p>Fertigkeiten und Nachteile können nicht mehr durch Anklicken gelöscht werden. 
          Bitte die &quot;Rückgängig&quot;-Taste benutzen.</p>
      </div>\n";
    }
?>
  </div>
  <div>
    <label for="charakter_name">Charaktername:</label>
    <input type="text" id="charakter_name" name="charakter_name" value="<?=$this->data->charakter_name?>" <?=$readonly?>>
  </div>
  <div>
    <label for="charakter_name">EP:</label>
    <input type="text" id="ep_gesamt" name="ep_gesamt" value="<?=$this->data->ep_gesamt?>" size="3" readonly>
  </div>
  <div>
    <label for="charakter_name">Übrige EP:</label>
    <input type="text" id="ep_rest" name="ep_rest" value="<?=$this->data->ep_rest?>" size="3" readonly>
  </div>
</div>

<?php
    $this->getHTMLPCGMain();
?>
<span id="tt_skill_not_available" class="tooltip">Für diese Rasse nicht erlaubt.</span>
<span id="tt_skill_no_ep" class="tooltip">Nicht genug EP.</span>
<span id="tt_skill_prereq" class="tooltip">Voraussetzungen: </span>


<div id="pcg_verlauf">
<div id="pcg_verlauf_header">Verlauf<span class="collapse" onClick="if($(this).hasClass('collapse')) { $(this).closest('div#pcg_verlauf').find('ul').hide(500); $(this).removeClass().addClass('expand'); } else { $(this).closest('div#pcg_verlauf').find('ul').show(500); $(this).removeClass().addClass('collapse'); }"></span></div>
<?=$this->getVerlauf();?>
<div id="pcg_verlauf_footer"></div>
</div>

<?php
    if(!$this->readonly) {
?>
<div id="dialog_immunitaet" class="dialog_container">
<div class="dialog_columns">
  <div class="dialog">
    <h4>Immunität</h4>
  </div>  
  <div class="form_controls_bottom">
    <input type="button" id="kdb_dialog_ok" name="kdb_dialog_ok" value="<?=_("OK")?>" onClick="pcgChooseImmunity($('#dialog_immunitaet ul li.active'), 1);">
    <input type="button" id="kdb_dialog_cancel" name="kdb_dialog_cancel" value="<?=_("Cancel")?>" onClick="$('#dialog_immunitaet').hide();">
  </div>
</div>
</div>
<?php
    }
?>

<div id="pcg_form_controls">
<?php
    if(!$this->readonly) {
?>
  <div style="float:right;">
    <input type="submit" id="kdb_delete" name="kdb_delete" value="Löschen" onClick="pcgDeleteChar(0); return false;">
<?php
    if($this->data->ist_tot)
      echo "    <input type=\"submit\" id=\"pcg_revive\" name=\"pcg_revive\" value=\"Wiederbeleben\" onClick=\"pcgDeleteChar(1); return false;\">\n";
    else
      echo "    <input type=\"submit\" id=\"pcg_death\" name=\"pcg_dead\" value=\"Tot\" onClick=\"pcgDeleteChar(1); return false;\">\n";
?>
  </div>
  <input type="submit" id="kdb_save" name="kdb_save" value="Sichern" onClick="pcgSaveChar(); return false;">
  <input type="submit" id="pcg_undo" name="pcg_undo" value="Rückgängig" onClick="pcgUndo(); return false;">
  <?php
    }
?>
  <input type="submit" id="pcg_getpdf" name="pcg_getpdf" value="PDF herunterladen">
</div>
</form>
<?php
  }
  
  ///////////////////////////////////////////////////////////////////////////////
  // get PDF
  //
  private function generate_pdf($pdf) {
    $pdf->SetFont('Arial','B',20);
    $pdf->setXY(18,25);
    $charakterName = $this->data->charakter_name;
    CWFTools::decodeHTMLChars($charakterName);
    $pdf->Cell(170,10, $charakterName);
    if (defined("CWF_PATH"))
      $pdf->Image(PCG_PATH."img/carta_logo.png", 165, 20);
    else
      $pdf->Image("carta_logo.png", 165, 20);
  
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(20,42);
    $pdf->Cell(30,5,"EP/EP-Rest:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(30,5, "{$this->data->ep_gesamt} / {$this->data->ep_rest}");
  
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(20,55.4);
    $pdf->Cell(20,5,"Spieler:");
    $pdf->SetFont('Arial','',11);
    $playerName = $this->data->player_familyname.", ".$this->data->player_givenname;
    CWFTools::decodeHTMLChars($playerName);
    $pdf->Cell(7,5, $playerName);
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(20,63.4);
    $pdf->Cell(20,5,"Rasse:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(7,5, $this->DB->result($this->DB->query("SELECT rasse FROM pcg2_rassen WHERE rasse_id='{$this->data->rasse_id}';"), 0, 0));
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(20,71.4);
    $pdf->Cell(20,5,"Religion:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(7,5, $this->DB->result($this->DB->query("SELECT gottheit FROM pcg2_goetter WHERE gottheit_id='{$this->data->gottheit_id}';"), 0, 0));
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(20,79.4);
    $pdf->Cell(20,5,"Herkunft:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(7,5, $this->DB->result($this->DB->query("SELECT land_name FROM pcg_laender WHERE land_id='{$this->data->land_id}';"), 0, 0).", ", 0, 2);
    $herkunft = $this->data->herkunft;
    CWFTools::decodeHTMLChars($herkunft);
    $pdf->Cell(7,5, $herkunft);
  
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(89,55.4);
    $pdf->Cell(12,5,"LP:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(7,5, $this->data->lp, 0, 0, "R");
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(89,63.4);
    $pdf->Cell(12,5,"MP:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(7,5, $this->data->mp, 0, 0, "R");
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(89,71.4);
    $pdf->Cell(12,5,"CP:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(7,5, $this->data->cp, 0, 0, "R");
    $pdf->SetFont('Arial','B',11);
    $pdf->setXY(89,79.4);
    $pdf->Cell(12,5,"SP:");
    $pdf->SetFont('Arial','',11);
    $pdf->Cell(7,5, $this->data->sp, 0, 0, "R");
  
    $pdf->SetFont('Arial','B',11);
    $pdf->Text(125,59,"Nachteile:");
    $pdf->SetFont('Arial','',11);
    $anz_nachteile = 1;
    foreach ($this->data->f_auswahl as $id => $fertigkeit) {
      if($fertigkeit['kategorie']=="Nachteil") {
        $str = $fertigkeit['fertigkeit']." (".array_sum($fertigkeit['ep']).")";
        $pdf->Text(125,61+(6*$anz_nachteile), $str);
  
        if ($fertigkeit['stufe'] <= 0) {
          $pdf->Line(125,60+(6*$anz_nachteile), 125+$pdf->GetStringWidth($str),60+(6*$anz_nachteile));
        }
  
        $anz_nachteile++;
      }
    }
  
    ////////////////////////////////////////////////////////////////////////////////
  
    $y_pos = 100;
    if ($anz_nachteile>4)
      $y_pos += 6*($anz_nachteile-4);
  
    $pdf->SetFont('Arial','B',11);
    $pdf->Text(21,$y_pos,"Fertigkeiten:");
    $pdf->SetFont('Arial','',11);
    $anz_fertigkeiten = 0;
    foreach ($this->data->f_auswahl as $id => $fertigkeit) {
      if(in_array($fertigkeit['kategorie'], array("Kampf", "Allgemein", "Magie"))) {
        $str = $fertigkeit['fertigkeit'].(($fertigkeit['max_stufe']>1) ? " {$fertigkeit['stufe']}" : "")." (".array_sum($fertigkeit['ep']).")";
        $pos = $y_pos+10+(6*$anz_fertigkeiten);
        $pdf->Text(21,$pos, $str);

        if ($fertigkeit['stufe'] <= 0) {
          $pdf->Line(21,$pos-1, 20+$pdf->GetStringWidth($str),$pos-1);
        }

        $anz_fertigkeiten++;
      }
    }
  
    $max_fertigkeiten = $anz_fertigkeiten;
  
    $pdf->SetFont('Arial','B',11);
    $pdf->Text(125,$y_pos,"Zauber & Tränke:");
    $pdf->SetFont('Arial','',11);
    $anz_fertigkeiten = 0;
    foreach ($this->data->f_auswahl as $id => $fertigkeit) {
      if(in_array($fertigkeit['kategorie'], 
                  array("Zauberei", "Schamanismus", "Klerikalmagie", "Bardenmagie", "Artefaktmagie", "Runenmagie", 
                        "Schwarze Magie", "Weiße Magie", "Alchemie", "Pharmazie"))) {
        $str = $fertigkeit['fertigkeit'].(($fertigkeit['max_stufe']>1) ? " {$fertigkeit['stufe']}" : "")." (".array_sum($fertigkeit['ep']).")";
        $pos = $y_pos+10+(6*$anz_fertigkeiten);
        $pdf->Text(125,$pos, $str);

        if ($fertigkeit['stufe'] <= 0) {
          $pdf->Line(125,$pos-1, 20+$pdf->GetStringWidth($str),$pos-1);
        }

        $anz_fertigkeiten++;
      }
    }
  
    if ($anz_fertigkeiten>$max_fertigkeiten)
      $max_fertigkeiten = $anz_fertigkeiten;
  
    ////////////////////////////////////////////////////////////////////////////////
  
    $y_pos = $y_pos+20+(6*$max_fertigkeiten);
  
    $pdf->SetFont('Arial','B',11);
    $pdf->Text(21,$y_pos,"Besuchte Spiele:");
    $pdf->SetFont('Arial','',11);
    $pos = $y_pos+5;
    $pdf->setXY(20,$pos);
  
    $anz_spiele=0;
    $anz_halbe=0;
    $spiele_str = array(array(),array());
    $spiele_ep_str = array(array(),array());
    foreach ($this->data->spiele as $spiel_id => $spiel) {
      if ($anz_spiele>=count($this->data->spiele)/2 && $anz_halbe==0) {
        $anz_halbe=$anz_spiele;
      }
      $spiele_str[($anz_halbe>0)][] .= $spiel."\n";
      $spiele_ep_str[($anz_halbe>0)][] .= $this->data->spiele_ep[$spiel_id]."\n";
  
      $anz_spiele++;
    }
    CWFTools::decodeHTMLChars($spiele_str);
    for ($i=0; $i<count($spiele_str[0]); $i++) {
      $pdf->Cell(65,5, $spiele_str[0][$i]);
      $pdf->Cell(10,5, $spiele_ep_str[0][$i]);
      $pdf->setX(105);
      $pdf->Cell(65,5, $spiele_str[1][$i]);
      $pdf->Cell(10,5, $spiele_ep_str[1][$i]);
      $pdf->setY($pdf->getY()+5);
    }
  
    ////////////////////////////////////////////////////////////////////////////////
    $y_pos = $y_pos+20+(6*$anz_spiele);
  
    $pdf->SetFont('Arial','B',11);
    $pdf->Write(6,"\n\nHintergrund:\n\n");
    $pdf->SetFont('Arial','',11);
    $hintergrund = $this->data->hintergrund;
    CWFTools::decodeHTMLChars($hintergrund);
    $pdf->Multicell(0,5, $hintergrund);

    $pdf->SetFont('Arial','B',11);
    $pdf->Write(6,"\n\nArtefakte:\n\n");
    $pdf->SetFont('Arial','',11);
    $artefakte = $this->data->artefakte;
    CWFTools::decodeHTMLChars($artefakte);
    $pdf->Multicell(0,5, $artefakte);
    
    return $pdf;
  }
}
?>
